Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 670902 - sys-apps/nix: top-level /nix directory triggers FHS/Gentoo policy paths message in gentoo/metadata/install-qa-check.d/08gentoo-paths
Summary: sys-apps/nix: top-level /nix directory triggers FHS/Gentoo policy paths messa...
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Portage team
URL:
Whiteboard:
Keywords: PATCH
Depends on:
Blocks:
 
Reported: 2018-11-11 11:40 UTC by Zac Medico
Modified: 2019-11-12 07:53 UTC (History)
4 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
install-qa-check.d: Support QA{,_STRICT}_INSTALL_PATHS variables (0001-install-qa-check.d-Support-QA-_STRICT-_INSTALL_PATHS.patch,1.67 KB, patch)
2018-11-11 23:01 UTC, Zac Medico
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Zac Medico gentoo-dev 2018-11-11 11:40:49 UTC
The gentoo/metadata/install-qa-check.d/08gentoo-paths script reports this issue:

>  * The ebuild is installing to one or more unexpected paths:
>  *
>  *   /nix
>  *
>  * Please fix the ebuild to use correct FHS/Gentoo policy paths.
I recommend to add /nix to the whitelist because this is the default location for all operating systems, as shown consistently throughout the installation instructions found at https://nixos.org/nix/manual/#chap-installation.

The nix manual also has this explicit warning in the "Building Nix from Source" section found at https://nixos.org/nix/manual/#sec-building-source:

> Warning: It is best not to change the Nix store from its default, since doing
> so makes it impossible to use pre-built binaries from the standard Nixpkgs
> channels — that is, all packages will need to be built from source.
Comment 1 Sergei Trofimovich gentoo-dev 2018-11-11 12:03:48 UTC
sys-apps/guix does the same for /gnu directory.
Comment 2 Sergei Trofimovich gentoo-dev 2018-11-11 12:07:26 UTC
While at it please update the comment of 08gentoo-paths file to reflect the maintainer to be dev-portage@, qa@ or something else. 60gtk-doc-paths is a good example.
Comment 3 Zac Medico gentoo-dev 2018-11-11 23:01:52 UTC
Created attachment 554938 [details, diff]
install-qa-check.d: Support QA{,_STRICT}_INSTALL_PATHS variables

Since we probably don't want to whitelist /nix for all ebuilds, this patch will allow use to whitelist it with a setting like this in global scope of the nix ebuilds:

QA_INSTALL_PATHS=( /nix )
Comment 4 Sergei Trofimovich gentoo-dev 2018-11-12 07:54:46 UTC
> Mikle Kolyada 2018-11-12 06:46:55 UTC
> Assignee: qa@gentoo.orgslyfox@gentoo.org

Please specify what is expected from me here.
Comment 5 Zac Medico gentoo-dev 2018-11-12 20:42:25 UTC
I've sent the QA_INSTALL_PATHS patch to the gentoo-dev mailing list for review:

https://archives.gentoo.org/gentoo-dev/message/e24dc875c69ccb3ab5a58eefdbac31db
Comment 6 Sergei Trofimovich gentoo-dev 2019-09-18 22:36:09 UTC
(In reply to Sergei Trofimovich from comment #2)
> While at it please update the comment of 08gentoo-paths file to reflect the
> maintainer to be dev-portage@, qa@ or something else. 60gtk-doc-paths is a
> good example.

Can we sort out maintainer status of this file? Otherwise given lack of activity here I suggest we assign maintainer to dev-portage@.
Comment 7 Sergei Trofimovich gentoo-dev 2019-11-03 22:26:03 UTC
(In reply to Sergei Trofimovich from comment #6)
> (In reply to Sergei Trofimovich from comment #2)
> > While at it please update the comment of 08gentoo-paths file to reflect the
> > maintainer to be dev-portage@, qa@ or something else. 60gtk-doc-paths is a
> > good example.
> 
> Can we sort out maintainer status of this file? Otherwise given lack of
> activity here I suggest we assign maintainer to dev-portage@.

Sent out https://archives.gentoo.org/gentoo-dev/message/d38401122b8ec43040b79a969cee5c43 for review.
Comment 8 Zac Medico gentoo-dev 2019-11-03 23:20:44 UTC
Can we get some kind of response from the QA team, since this thing was added by @mgorny:

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=67ffc42815419f5b33698f5739de321f6a6edd4a

@slyfox, if the QA team doesn't respond or we're not happy with the response, then I suppose we'll have to escalate it to the council.
Comment 9 Michał Górny archtester Gentoo Infrastructure gentoo-dev Security 2019-11-04 07:29:39 UTC
Just add it to allowed_paths_toplevel.
Comment 10 Larry the Git Cow gentoo-dev 2019-11-11 22:25:00 UTC
The bug has been referenced in the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=61d8c12e7207b9e22b9d63692e8157a314101742

commit 61d8c12e7207b9e22b9d63692e8157a314101742
Author:     Sergei Trofimovich <slyfox@gentoo.org>
AuthorDate: 2019-11-03 22:14:22 +0000
Commit:     Sergei Trofimovich <slyfox@gentoo.org>
CommitDate: 2019-11-11 22:24:51 +0000

    metadata/install-qa-check.d/08gentoo-paths: add explicit maintainer
    
    Bugs like bug #670902 get stuck due to unclear maintainership status.
    Let's assign it to dev-portage@ as it historicallily lived in portage
    source tree and QA does not take it over in bug #670902.
    
    Bug: https://bugs.gentoo.org/670902
    Signed-off-by: Sergei Trofimovich <slyfox@gentoo.org>

 metadata/install-qa-check.d/08gentoo-paths | 3 +++
 1 file changed, 3 insertions(+)
Comment 11 Sergei Trofimovich gentoo-dev 2019-11-11 22:25:47 UTC
All yours :)
Comment 12 Larry the Git Cow gentoo-dev 2019-11-11 23:05:24 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=598e450e5615e32a63c5fd6f3a9ce65ffc557b4f

commit 598e450e5615e32a63c5fd6f3a9ce65ffc557b4f
Author:     Zac Medico <zmedico@gentoo.org>
AuthorDate: 2019-11-11 23:03:40 +0000
Commit:     Zac Medico <zmedico@gentoo.org>
CommitDate: 2019-11-11 23:04:48 +0000

    install-qa-check.d/08gentoo-paths: add nix to allowed_paths_toplevel
    
    Closes: https://bugs.gentoo.org/670902
    Suggested-by: Michał Górny <mgorny@gentoo.org>
    Signed-off-by: Zac Medico <zmedico@gentoo.org>

 metadata/install-qa-check.d/08gentoo-paths | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)
Comment 13 Larry the Git Cow gentoo-dev 2019-11-12 07:53:31 UTC
The bug has been referenced in the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=5a11dc4c64a5b98067e9e350e608b1bf0a7162e3

commit 5a11dc4c64a5b98067e9e350e608b1bf0a7162e3
Author:     Sergei Trofimovich <slyfox@gentoo.org>
AuthorDate: 2019-11-12 07:46:04 +0000
Commit:     Sergei Trofimovich <slyfox@gentoo.org>
CommitDate: 2019-11-12 07:53:20 +0000

    metadata/install-qa-check.d/08gentoo-paths: add guix
    
    sys-apps/nix and sys-apps/guix are twins:
    - sys-apps/nix manages /nix/store
    - sys-apps/guix manages /gnu/store
    
    Added 'gnu' and mentioned packages that own the directory.
    
    Bug: https://bugs.gentoo.org/670902
    Signed-off-by: Sergei Trofimovich <slyfox@gentoo.org>

 metadata/install-qa-check.d/08gentoo-paths | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)